Index: ex/ex.c
Prereq: 	10.57 
*** nvi-1.79/ex/ex.c	Fri Oct 11 07:49:46 1996
--- nvi-1.79-m17n/ex/ex.c	Thu Feb 20 00:37:04 1997
***************
*** 205,213 ****
--- 205,222 ----
  	u_int32_t flags;
  	long ltmp;
  	int at_found, gv_found;
+ #ifndef MULTIBYTE
  	int ch, cnt, delim, isaddr, namelen;
+ #else
+ 	CHAR_T ch;
+ 	int cnt, delim, isaddr, namelen;
+ #endif /*MULTIBYTE*/
  	int newscreen, notempty, tmp, vi_address;
+ #ifndef MULTIBYTE
  	char *arg1, *p, *s, *t;
+ #else
+ 	CHAR_T *arg1, *p, *s, *t;
+ #endif
  
  	gp = sp->gp;
  	exp = EXP(sp);
***************
*** 755,760 ****
--- 764,778 ----
  					--ecp->clen;
  				} else if (ecp->cp[0] == delim)
  					--cnt;
+ #ifdef MULTIBYTE
+ 				else if (1 < KEY_BLEN(sp, ecp->cp[0])) {
+ 					size_t advance;
+ 					
+ 					advance = KEY_BLEN(sp, ecp->cp[0]);
+ 					ecp->clen -= (advance - 1);
+ 					ecp->cp += (advance - 1);
+ 				}
+ #endif /*MULTIBYTE*/
  		}
  	}
  
***************
*** 792,797 ****
--- 810,828 ----
  			--ecp->clen;
  			break;
  		}
+ #ifdef MULTIBYTE
+ 		else if (1 <= KEY_BLEN(sp, ch)) {
+ 			size_t advance;
+ 
+ 			advance = KEY_BLEN(sp, ch);
+ 			ecp->clen -= (advance - 1);
+ 			advance--;
+ 			while (advance--)
+ 				*p++ = *ecp->cp++;
+ 			*p++ = ecp->cp[0];
+ 			continue;
+ 		}
+ #endif /*MULTIBYTE*/
  		*p++ = ch;
  	}
  
***************
*** 1823,1829 ****
--- 1854,1864 ----
  	long total, val;
  	int isneg;
  	int (*sf) __P((SCR *, MARK *, MARK *, char *, size_t, char **, u_int));
+ #ifndef MULTIBYTE
  	char *endp;
+ #else
+ 	CHAR_T *endp;
+ #endif
  
  	gp = sp->gp;
  	exp = EXP(sp);
Index: ex/ex.h
Prereq: 	10.24 
*** nvi-1.79/ex/ex.h	Tue Aug 13 09:24:00 1996
--- nvi-1.79-m17n/ex/ex.h	Thu Feb 20 00:36:58 1997
***************
*** 80,89 ****
--- 80,97 ----
  	memset(&((cmdp)->cp), 0, ((char *)&(cmdp)->flags -		\
  	    (char *)&((cmdp)->cp)) + sizeof((cmdp)->flags))
  
+ #ifndef MULTIBYTE
  	char	 *cp;			/* Current command text. */
+ #else
+ 	CHAR_T	 *cp;			/* Current command text. */
+ #endif
  	size_t	  clen;			/* Current command length. */
  
+ #ifndef MULTIBYTE
  	char	 *save_cmd;		/* Remaining command. */
+ #else
+ 	CHAR_T	 *save_cmd;		/* Remaining command. */
+ #endif
  	size_t	  save_cmdlen;		/* Remaining command length. */
  
  	EXCMDLIST const *cmd;		/* Command: entry in command table. */
***************
*** 91,97 ****
--- 99,109 ----
  
  	CIRCLEQ_HEAD(_rh, _range) rq;	/* @/global range: linked list. */
  	recno_t   range_lno;		/* @/global range: set line number. */
+ #ifndef MULTIBYTE
  	char	 *o_cp;			/* Original @/global command. */
+ #else
+ 	CHAR_T	 *o_cp;			/* Original @/global command. */
+ #endif
  	size_t	  o_clen;		/* Original @/global command length. */
  #define	AGV_AT		0x01		/* @ buffer execution. */
  #define	AGV_AT_NORANGE	0x02		/* @ buffer execution without range. */
Index: ex/ex_argv.c
Prereq: 	10.26 
*** nvi-1.79/ex/ex_argv.c	Sat Sep 21 09:33:02 1996
--- nvi-1.79-m17n/ex/ex_argv.c	Thu Feb 20 00:29:24 1997
***************
*** 100,106 ****
--- 100,111 ----
  {
  	EX_PRIVATE *exp;
  	size_t blen, len;
+ #ifndef MULTIBYTE
  	char *bp, *p, *t;
+ #else
+ 	char *bp, *t;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	GET_SPACE_RET(sp, bp, blen, 512);
  
***************
*** 143,149 ****
--- 148,159 ----
  {
  	size_t blen, len, n;
  	int rval;
+ #ifndef MULTIBYTE
  	char *bp, *mp, *p;
+ #else
+ 	char *bp, *mp;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	GET_SPACE_RET(sp, bp, blen, 512);
  
***************
*** 256,262 ****
--- 266,277 ----
  	EX_PRIVATE *exp;
  	size_t len;
  	int ch, off;
+ #ifndef MULTIBYTE
  	char *ap, *p;
+ #else
+ 	char *ap;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	for (exp = EXP(sp); cmdlen > 0; ++exp->argsoff) {
  		/* Skip any leading whitespace. */
***************
*** 621,627 ****
--- 636,647 ----
  	pid_t pid;
  	size_t blen, len;
  	int ch, std_output[2];
+ #ifndef MULTIBYTE
  	char *bp, *p, *sh, *sh_path;
+ #else
+ 	char *bp, *sh, *sh_path;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	/* Secure means no shell access. */
  	if (O_ISSET(sp, O_SECURE)) {
Index: ex/ex_global.c
Prereq: 	10.22 
*** nvi-1.79/ex/ex_global.c	Fri Oct 11 07:41:45 1996
--- nvi-1.79-m17n/ex/ex_global.c	Mon Dec 30 23:10:44 1996
***************
*** 128,133 ****
--- 128,143 ----
  				++p;
  			else if (p[1] == '\\')
  				*t++ = *p++;
+ #ifdef MULTIBYTE
+ 		if (1 < KEY_BLEN(sp, p[0])) {
+ 			size_t advance;
+ 
+ 			advance = KEY_BLEN(sp, p[0]);
+ 			advance--;
+ 			while (advance--)
+ 				*t++ = *p++;
+ 		}
+ #endif /*MULTIBYTE*/
  		*t++ = *p++;
  	}
  
Index: ex/ex_join.c
Prereq: 	10.10 
*** nvi-1.79/ex/ex_join.c	Mon Sep 16 04:59:12 1996
--- nvi-1.79-m17n/ex/ex_join.c	Thu Feb 20 00:31:26 1997
***************
*** 38,45 ****
--- 38,52 ----
  {
  	recno_t from, to;
  	size_t blen, clen, len, tlen;
+ #ifndef MULTIBYTE
  	int echar, extra, first;
  	char *bp, *p, *tbp;
+ #else
+ 	int extra, first;
+ 	char *bp, *tbp;
+ 	CHAR_T echar;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	NEEDFILE(sp, cmdp);
  
***************
*** 111,116 ****
--- 118,146 ----
  		 */
  		extra = 0;
  		if (!first && !FL_ISSET(cmdp->iflags, E_C_FORCE)) {
+ #ifdef MULTIBYTE
+ 			/*
+ 			 * Here we implement behavior just as same as jelvis.
+ 			 *	last char	first char	behavior
+ 			 *	---		---		---
+ 			 *	multibyte	multibyte	nothing ins'ed
+ 			 *	multibyte	singlebyte	1 spc ins'ed
+ 			 *	singlebyte	multibyte	1 spc ins'ed
+ 			 *	singlebyte	singlebyte	original
+ 			 */
+ 			if (1 < KEY_BLEN(sp, echar)) {
+ 				if (1 < KEY_BLEN(sp, p[0]))
+ 					; /*nothing*/
+ 				else {
+ 					*tbp++ = ' ';
+ 					++clen;
+ 					for (; len && isblank(*p); --len, ++p);
+ 				}
+ 			} else if (1 < KEY_BLEN(sp, p[0])) {
+ 				*tbp++ = ' ';
+ 				++clen;
+ 			} else
+ #endif /*MULTIBYTE*/
  			if (isblank(echar))
  				for (; len && isblank(*p); --len, ++p);
  			else if (p[0] != ')') {
***************
*** 129,135 ****
--- 159,169 ----
  			memcpy(tbp, p, len);
  			tbp += len;
  			clen += len;
+ #ifndef MULTIBYTE
  			echar = p[len - 1];
+ #else
+ 			echar = p[len - multi_back(sp, p, &p[len])];
+ #endif
  		} else
  			echar = ' ';
  
***************
*** 153,162 ****
  		 * line.
  		 */
  		if (first) {
  			sp->cno = (tbp - bp) - (1 + extra);
  			first = 0;
! 		} else
  			sp->cno = (tbp - bp) - len - (1 + extra);
  	}
  	sp->lno = cmdp->addr1.lno;
  
--- 187,211 ----
  		 * line.
  		 */
  		if (first) {
+ #ifndef MULTIBYTE
  			sp->cno = (tbp - bp) - (1 + extra);
+ #else
+ 			sp->cno = (tbp - bp);
+ 			sp->cno -= multi_back(sp, bp, &p[sp->cno]);
+ 			if (extra)
+ 				sp->cno -= multi_back(sp, bp, &bp[sp->cno]);
+ #endif /*MULTIBYTE*/
  			first = 0;
! 		} else {
! #ifndef MULTIBYTE
  			sp->cno = (tbp - bp) - len - (1 + extra);
+ #else
+ 			sp->cno = (tbp - bp) - len;
+ 			sp->cno -= multi_back(sp, bp, &bp[sp->cno]);
+ 			if (extra)
+ 				sp->cno -= multi_back(sp, bp, &bp[sp->cno]);
+ #endif /*MULTIBYTE*/
+ 		}
  	}
  	sp->lno = cmdp->addr1.lno;
  
Index: ex/ex_print.c
Prereq: 	10.18 
*** nvi-1.79/ex/ex_print.c	Mon May 13 07:07:43 1996
--- nvi-1.79-m17n/ex/ex_print.c	Fri Feb 28 14:40:42 1997
***************
*** 30,36 ****
  
  #include "../common/common.h"
  
! static int ex_prchars __P((SCR *, const char *, size_t *, size_t, u_int, int));
  
  /*
   * ex_list -- :[line [,line]] l[ist] [count] [flags]
--- 30,36 ----
  
  #include "../common/common.h"
  
! static int ex_prchars __P((SCR *, const CHAR_T *, size_t *, size_t, u_int, int));
  
  /*
   * ex_list -- :[line [,line]] l[ist] [count] [flags]
***************
*** 220,226 ****
--- 220,230 ----
  static int
  ex_prchars(sp, p, colp, len, flags, repeatc)
  	SCR *sp;
+ #ifndef MULTIBYTE
  	const char *p;
+ #else
+ 	const CHAR_T *p;
+ #endif
  	size_t *colp, len;
  	u_int flags;
  	int repeatc;
***************
*** 228,240 ****
  	CHAR_T ch, *kp;
  	GS *gp;
  	size_t col, tlen, ts;
  
  	if (O_ISSET(sp, O_LIST))
  		LF_SET(E_C_LIST);
  	gp = sp->gp;
  	ts = O_VAL(sp, O_TABSTOP);
! 	for (col = *colp; len--;)
! 		if ((ch = *p++) == '\t' && !LF_ISSET(E_C_LIST))
  			for (tlen = ts - col % ts;
  			    col < sp->cols && tlen--; ++col) {
  				(void)ex_printf(sp,
--- 232,247 ----
  	CHAR_T ch, *kp;
  	GS *gp;
  	size_t col, tlen, ts;
+ #ifdef MULTIBYTE
+ 	size_t madv;
+ #endif
  
  	if (O_ISSET(sp, O_LIST))
  		LF_SET(E_C_LIST);
  	gp = sp->gp;
  	ts = O_VAL(sp, O_TABSTOP);
! 	for (col = *colp; len--;) {
! 		if ((ch = *p) == '\t' && !LF_ISSET(E_C_LIST))
  			for (tlen = ts - col % ts;
  			    col < sp->cols && tlen--; ++col) {
  				(void)ex_printf(sp,
***************
*** 242,247 ****
--- 249,277 ----
  				if (INTERRUPTED(sp))
  					goto intr;
  			}
+ #ifdef MULTIBYTE
+ 		else if (1 < (madv = KEY_BLEN(sp, *p))) {
+ 			/*
+ 			 * Leave multibyte char as is.  Be careful.
+ 			 */
+ 			kp = multi_rawname(sp, p);
+ 			tlen = KEY_LEN(sp, *p);
+ 			if (col + tlen <= sp->cols) {
+ 				(void)ex_puts(sp, kp);
+ 				col += tlen;
+ 			} else {
+ 				while (col + tlen < sp->cols) {
+ 					(void)ex_puts(sp, " ");
+ 					col++;
+ 				}
+ 				(void)ex_puts(sp, kp);
+ 				col = tlen;
+ 			}
+ 
+ 			p += (madv - 1);	/*add one at end of loop*/
+ 			len -= (madv - 1);	/*subtract one at top of loop*/
+ 		}
+ #endif
  		else {
  			kp = KEY_NAME(sp, ch);
  			tlen = KEY_LEN(sp, ch);
***************
*** 260,265 ****
--- 290,297 ----
  						goto intr;
  				}
  		}
+ 		p++;
+ 	}
  intr:	*colp = col;
  	return (0);
  }
Index: ex/ex_read.c
Prereq: 	10.38 
*** nvi-1.79/ex/ex_read.c	Tue Aug 13 09:37:00 1996
--- nvi-1.79-m17n/ex/ex_read.c	Fri Apr  4 12:17:55 1997
***************
*** 317,336 ****
--- 317,370 ----
  	ccnt = 0;
  	lcnt = 0;
  	p = "147|Reading...";
+ #ifdef MULTIBYTE
+ 	if (!silent)
+ 		gp->scr_busy(sp, p, BUSY_ON);
+ #endif /*MULTIBYTE*/
  	for (lno = fm->lno; !ex_getline(sp, fp, &len); ++lno, ++lcnt) {
  		if ((lcnt + 1) % INTERRUPT_CHECK == 0) {
  			if (INTERRUPTED(sp))
  				break;
+ #ifndef MULTIBYTE
  			if (!silent) {
  				gp->scr_busy(sp, p,
  				    p == NULL ? BUSY_UPDATE : BUSY_ON);
  				p = NULL;
  			}
+ #else
+ 			/*
+ 			 * We can't do BUSY_UPDATE here, since the buffer
+ 			 * contains bytestream read from the file,
+ 			 * not internal expression.
+ 			 */
+ #endif /*MULTIBYTE*/
  		}
  		if (db_append(sp, 1, lno, exp->ibp, len))
  			goto err;
  		ccnt += len;
  	}
+ 
+ #ifdef MULTIBYTE
+     {
+ 	MARK start, end;
+ 	int tmp;
+ 
+ 	tmp = F_ISSET(sp->ep, F_MODIFIED);
+ 
+ 	start.lno = fm->lno + 1;
+ 	end.lno = start.lno + lcnt - 1;
+ 	start.cno = end.cno = 0;
+ 	multi_ext2int_region(sp, &start, &end, O_FILEENCODING,
+ 		O_STR(sp, O_AUTODETECT), 1, 0);
+ 	if (end.lno != start.lno + lcnt - 1)
+ 		lcnt = end.lno - start.lno + 1;
+ 
+ 	if (tmp)
+ 		F_SET(sp->ep, F_MODIFIED);
+ 	else
+ 		F_CLR(sp->ep, F_MODIFIED);
+     }
+ #endif /*MULTIBYTE*/
  
  	if (ferror(fp) || fclose(fp))
  		goto err;
Index: ex/ex_script.c
Prereq: 	10.30 
*** nvi-1.79/ex/ex_script.c	Wed Sep 25 09:51:12 1996
--- nvi-1.79-m17n/ex/ex_script.c	Fri Apr  4 12:18:10 1997
***************
*** 344,351 ****
--- 344,388 ----
  
  	/* Push the line to the shell. */
  	sc = sp->script;
+ #ifndef MULTIBYTE
  	if ((nw = write(sc->sh_master, p, len)) != len)
  		goto err2;
+ #else
+     {
+ 	void *cnvstate;
+ 	size_t ilen;
+ 	int mbflg;
+ 
+ 	cnvstate = multi_cnvstart(sp, O_STR(sp, O_FILEENCODING));
+ 
+ 	ilen = multi_int2extlen(sp, p, len, &mbflg, cnvstate);
+ 	if (!mbflg) {
+ 		if ((nw = write(sc->sh_master, p, len)) != len) {
+ 			multi_cnvfinish(sp, cnvstate);
+ 			goto err2;
+ 		}
+ 	} else {
+ 		CHAR_T *tp;
+ 		size_t tlen;
+ 
+ 		GET_SPACE_RET(sp, tp, tlen, ilen);
+ 		memcpy(tp, p, len);
+ 		if (multi_int2ext(sp, tp, len, ilen, cnvstate)) {
+ 			FREE_SPACE(sp, tp, tlen);
+ 			multi_cnvfinish(sp, cnvstate);
+ 			goto err2;
+ 		}
+ 		if ((nw = write(sc->sh_master, tp, ilen)) != ilen) {
+ 			FREE_SPACE(sp, tp, tlen);
+ 			multi_cnvfinish(sp, cnvstate);
+ 			goto err2;
+ 		}
+ 		
+ 		FREE_SPACE(sp, tp, tlen);
+ 	}
+ 	multi_cnvfinish(sp, cnvstate);
+     }
+ #endif /*MULTIBYTE*/
  	rval = 0;
  	if (write(sc->sh_master, "\n", 1) != 1) {
  err2:		if (nw == 0)
***************
*** 431,440 ****
--- 468,483 ----
  	u_int value;
  	int nr, rval;
  	char *bp;
+ #ifdef MULTIBYTE
+ 	recno_t lno0;
+ #endif
  
  	/* Find out where the end of the file is. */
  	if (db_last(sp, &lno))
  		return (1);
+ #ifdef MULTIBYTE
+ 	lno0 = lno;
+ #endif
  
  #define	MINREAD	1024
  	GET_SPACE_RET(sp, bp, blen, MINREAD);
***************
*** 493,501 ****
--- 536,566 ----
  			goto ret;
  	}
  
+ #ifdef MULTIBYTE
+     {
+ 	/* convert chars into internal encoding. */
+ 	MARK start, end;
+ 	start.lno = (lno == 0 ? 0 : lno0 + 1);
+ 	end.lno = lno;
+ 	start.cno = end.cno = 0;
+ 	multi_ext2int_region(sp, &start, &end, O_FILEENCODING, NULL, 1, 0);
+ 	lno = end.lno;
+     }
+ #endif /*MULTIBYTE*/
+ 
  	/* The cursor moves to EOF. */
  	sp->lno = lno;
+ #ifndef MULTIBYTE
  	sp->cno = len ? len - 1 : 0;
+ #else
+ 	if (!len)
+ 		sp->cno = 0;
+ 	else {
+ 		if (db_get(sp, lno, DBG_FATAL, &p, &len))
+ 			return (1);
+ 		sp->cno = len - multi_back(sp, p, &p[len]);
+ 	}
+ #endif
  	rval = vs_refresh(sp, 1);
  
  ret:	FREE_SPACE(sp, bp, blen);
Index: ex/ex_subst.c
Prereq: 	10.37 
*** nvi-1.79/ex/ex_subst.c	Mon Sep 16 04:59:58 1996
--- nvi-1.79-m17n/ex/ex_subst.c	Fri Feb 21 23:01:38 1997
***************
*** 32,42 ****
--- 32,51 ----
  #define	SUB_FIRST	0x01		/* The 'r' flag isn't reasonable. */
  #define	SUB_MUSTSETR	0x02		/* The 'r' flag is required. */
  
+ #ifndef MULTIBYTE
  static int re_conv __P((SCR *, char **, size_t *, int *));
  static int re_cscope_conv __P((SCR *, char **, size_t *, int *));
+ #else
+ static int re_conv __P((SCR *, CHAR_T **, size_t *, int *));
+ static int re_cscope_conv __P((SCR *, CHAR_T **, size_t *, int *));
+ #endif /*MULTIBYTE*/
  static int re_sub __P((SCR *,
  		char *, char **, size_t *, size_t *, regmatch_t [10]));
+ #ifndef MULTIBYTE
  static int re_tag_conv __P((SCR *, char **, size_t *, int *));
+ #else
+ static int re_tag_conv __P((SCR *, CHAR_T **, size_t *, int *));
+ #endif
  static int s __P((SCR *, EXCMD *, char *, regex_t *, u_int));
  
  /*
***************
*** 55,62 ****
--- 64,77 ----
  	regex_t *re;
  	size_t blen, len;
  	u_int flags;
+ #ifndef MULTIBYTE
  	int delim;
  	char *bp, *ptrn, *rep, *p, *t;
+ #else
+ 	CHAR_T delim;
+ 	char *bp, *ptrn, *rep, *t;
+ 	CHAR_T *p;
+ #endif /*MULTIBYTE*/
  
  	/*
  	 * Skip leading white space.
***************
*** 126,131 ****
--- 141,156 ----
  				++p;
  			else if (p[1] == '\\')
  				*t++ = *p++;
+ #ifdef MULTIBYTE
+ 		if (1 < KEY_BLEN(sp, p[0])) {
+ 			size_t advance;
+ 
+ 			advance = KEY_BLEN(sp, p[0]);
+ 			advance--;
+ 			while (advance--)
+ 				*t++ = *p++;
+ 		}
+ #endif /*MULTIBYTE*/
  		*t++ = *p++;
  	}
  
***************
*** 198,205 ****
--- 223,236 ----
  	} else if (p[0] == '%' && (p[1] == '\0' || p[1] == delim))
  		p += p[1] == delim ? 2 : 1;
  	else {
+ #ifndef MULTIBYTE
  		for (rep = p, len = 0;
  		    p[0] != '\0' && p[0] != delim; ++p, ++len)
+ #else
+ 		for (rep = p, len = 0;
+ 		     p[0] != '\0' && p[0] != delim;
+ 		     len += KEY_BLEN(sp, *p), p += KEY_BLEN(sp, *p))
+ #endif /*MULTIBYTE*/
  			if (p[0] == '~')
  				len += sp->repl_len;
  		GET_SPACE_RET(sp, bp, blen, len);
***************
*** 227,232 ****
--- 258,274 ----
  				len += sp->repl_len;
  				continue;
  			}
+ #ifdef MULTIBYTE
+ 			else if (1 <= KEY_BLEN(sp, p[0])) {
+ 				size_t advance;
+ 
+ 				advance = KEY_BLEN(sp, p[0]);
+ 				len += advance;
+ 				while (advance--)
+ 					*t++ = *p++;
+ 				continue;
+ 			}
+ #endif /*MULTIBYTE*/
  			*t++ = *p++;
  			++len;
  		}
***************
*** 628,637 ****
--- 670,690 ----
  				 * It would be nice to change the vi code so
  				 * that we could display a cursor past EOL.
  				 */
+ #ifndef MULTIBYTE
  				if (to.cno >= llen)
  					to.cno = llen - 1;
  				if (from.cno >= llen)
  					from.cno = llen - 1;
+ #else
+ 				if (to.cno >= llen) {
+ 					to.cno = llen - multi_back(sp, s,
+ 								&s[llen]);
+ 				}
+ 				if (from.cno >= llen) {
+ 					from.cno = llen - multi_back(sp, s,
+ 								&s[llen]);
+ 				}
+ #endif /*MULTIBYTE*/
  
  				sp->lno = from.lno;
  				sp->cno = from.cno;
***************
*** 1025,1037 ****
--- 1078,1098 ----
  static int
  re_conv(sp, ptrnp, plenp, replacedp)
  	SCR *sp;
+ #ifndef MULTIBYTE
  	char **ptrnp;
+ #else
+ 	CHAR_T **ptrnp;
+ #endif
  	size_t *plenp;
  	int *replacedp;
  {
  	size_t blen, len, needlen;
  	int magic;
+ #ifndef MULTIBYTE
  	char *bp, *p, *t;
+ #else
+ 	CHAR_T *bp, *p, *t;
+ #endif
  
  	/*
  	 * First pass through, we figure out how much space we'll need.
***************
*** 1089,1094 ****
--- 1150,1165 ----
  			}
  			break;
  		default:
+ #ifdef MULTIBYTE
+ 		    {
+ 			size_t advance;
+ 			if (1 <= (advance = KEY_BLEN(sp, *p))) {
+ 				needlen += advance;
+ 				p += advance;
+ 				break;
+ 			}
+ 		    }
+ #endif /*MULTIBYTE*/
  			needlen += 1;
  			break;
  		}
***************
*** 1156,1161 ****
--- 1227,1246 ----
  			*t++ = *p;
  			break;
  		default:
+ #ifdef MULTIBYTE
+ 		    {
+ 			size_t advance;
+ 
+ 			if (1 < (advance = KEY_BLEN(sp, *p))) {
+ 				len -= (advance - 1);
+ 				advance--;
+ 				while (advance--)
+ 					*t++ = *p++;
+ 				*t++ = *p;
+ 				break;
+ 			}
+ 		    }
+ #endif /*MUTLIBYTE*/
  			*t++ = *p;
  			break;
  		}
***************
*** 1173,1185 ****
--- 1258,1278 ----
  static int
  re_tag_conv(sp, ptrnp, plenp, replacedp)
  	SCR *sp;
+ #ifndef MULTIBYTE
  	char **ptrnp;
+ #else
+ 	CHAR_T **ptrnp;
+ #endif
  	size_t *plenp;
  	int *replacedp;
  {
  	size_t blen, len;
  	int lastdollar;
+ #ifndef MULTIBYTE
  	char *bp, *p, *t;
+ #else
+ 	CHAR_T *bp, *p, *t;
+ #endif
  
  	len = *plenp;
  
***************
*** 1190,1195 ****
--- 1283,1296 ----
  	p = *ptrnp;
  	t = bp;
  
+ #ifdef MULTIBYTE
+ 	/* if the last char is multibyte, we don't check that. */
+ 	if (len > 0 && 1 < multi_back(sp, p, &p[len])) {
+ 		lastdollar = 0;
+ 		goto skiplastch;
+ 	}
+ #endif /*MULTIBYTE*/
+ 
  	/* If the last character is a '/' or '?', we just strip it. */
  	if (len > 0 && (p[len - 1] == '/' || p[len - 1] == '?'))
  		--len;
***************
*** 1201,1206 ****
--- 1302,1310 ----
  	} else
  		lastdollar = 0;
  
+ #ifdef MULTIBYTE
+ skiplastch:
+ #endif
  	/* If the first character is a '/' or '?', we just strip it. */
  	if (len > 0 && (p[0] == '/' || p[0] == '?')) {
  		++p;
***************
*** 1222,1227 ****
--- 1326,1341 ----
  		if (p[0] == '\\' && (p[1] == '/' || p[1] == '?')) {
  			++p;
  			--len;
+ #ifdef MULTIBYTE
+ 		} else if (1 < KEY_BLEN(sp, p[0])) {
+ 			size_t advance;
+ 
+ 			advance = KEY_BLEN(sp, p[0]);
+ 			len -= (advance - 1);
+ 			advance--;
+ 			while (advance--)
+ 				*t++ = *p++;
+ #endif /*MULTIBYTE*/
  		} else if (strchr("^.[]$*", p[0]))
  			*t++ = '\\';
  		*t++ = *p++;
***************
*** 1242,1253 ****
--- 1356,1375 ----
  static int
  re_cscope_conv(sp, ptrnp, plenp, replacedp)
  	SCR *sp;
+ #ifndef MULTIBYTE
  	char **ptrnp;
+ #else
+ 	CHAR_T **ptrnp;
+ #endif
  	size_t *plenp;
  	int *replacedp;
  {
  	size_t blen, len, nspaces;
+ #ifndef MULTIBYTE
  	char *bp, *p, *t;
+ #else
+ 	CHAR_T *bp, *p, *t;
+ #endif
  
  	/*
  	 * Each space in the source line printed by cscope represents an
***************
*** 1279,1284 ****
--- 1401,1417 ----
  		if (*p == ' ') {
  			memcpy(t, CSCOPE_RE_SPACE, sizeof(CSCOPE_RE_SPACE) - 1);
  			t += sizeof(CSCOPE_RE_SPACE) - 1;
+ #ifdef MULTIBYTE
+ 		} else if (1 < KEY_BLEN(sp, *p)) {
+ 			size_t advance;
+ 
+ 			advance = KEY_BLEN(sp, *p);
+ 			len -= (advance - 1);	/*plus one at for loop*/
+ 			advance--;
+ 			while (advance--)
+ 				*t++ = *p++;
+ 			*t++ = *p;		/*plus one at for loop*/
+ #endif /*MULTIBYTE*/
  		} else {
  			if (strchr("\\^.[]$*+?()|{}", *p))
  				*t++ = '\\';
***************
*** 1335,1344 ****
--- 1468,1487 ----
  	size_t lbclen, lblen;		/* Local copies. */
  	size_t mlen;			/* Match length. */
  	size_t rpl;			/* Remaining replacement length. */
+ #ifndef MULTIBYTE
  	char *rp;			/* Replacement pointer. */
  	int ch;
+ #else
+ 	CHAR_T *rp;			/* Replacement pointer. */
+ 	CHAR_T ch;
+ #endif
  	int no;				/* Match replacement offset. */
+ #ifndef MULTIBYTE
  	char *p, *t;			/* Buffer pointers. */
+ #else
+ 	CHAR_T *p;
+ 	char *t;			/* Buffer pointers. */
+ #endif
  	char *lb;			/* Local copies. */
  
  	lb = *lbp;			/* Get local copies. */
***************
*** 1448,1453 ****
--- 1591,1622 ----
  				++rp;
  				break;
  			}
+ #ifdef MULTIBYTE
+ 		default:
+ 		    {
+ 			size_t advance;
+ 
+ 			if (1 == (advance = KEY_BLEN(sp, ch)))
+ 				break;
+ 
+ 			/*
+ 			 * Multibyte chars must go through.
+ 			 *
+ 			 * XXX
+ 			 * It would be better if we can do \u or \l
+ 			 * to multibyte chars.
+ 			 */
+ 			NEEDSP(sp, advance, p);
+ 			lbclen += advance;
+ 			rpl -= (advance - 1);
+ 
+ 			*p++ = ch;
+ 			advance--;
+ 			while (advance--)
+ 				*p++ = *rp++;
+ 			continue;
+ 		    }
+ #endif /*MULTIBYTE*/
  		}
  		OUTCH(ch, 1);
  	}
Index: ex/ex_txt.c
Prereq: 	10.17 
*** nvi-1.79/ex/ex_txt.c	Fri Oct 11 07:44:58 1996
--- nvi-1.79-m17n/ex/ex_txt.c	Sun Dec 29 21:43:56 1996
***************
*** 168,175 ****
--- 168,180 ----
  			 * don't discard the backslash because we need it
  			 * to get the <newline> through the ex parser.
  			 */
+ #ifndef MULTIBYTE
  			if (LF_ISSET(TXT_BACKSLASH) &&
  			    tp->len != 0 && tp->lb[tp->len - 1] == '\\')
+ #else
+ 			if (LF_ISSET(TXT_BACKSLASH) && tp->len != 0 &&
+ 			    tp->lb[tp->len - multi_back(sp, tp->lb, &tp->lb[tp->len])] == '\\')
+ #endif /*MULTIBYTE*/
  				goto ins_ch;
  
  			/*
***************
*** 187,194 ****
  			 * '.' may terminate text input mode; free the current
  			 * TEXT.
  			 */
  			if (LF_ISSET(TXT_DOTTERM) && tp->len == tp->ai + 1 &&
! 			    tp->lb[tp->len - 1] == '.') {
  notlast:			CIRCLEQ_REMOVE(tiqh, tp, q);
  				text_free(tp);
  				goto done;
--- 192,205 ----
  			 * '.' may terminate text input mode; free the current
  			 * TEXT.
  			 */
+ #ifndef MULTIBYTE
  			if (LF_ISSET(TXT_DOTTERM) && tp->len == tp->ai + 1 &&
! 			    tp->lb[tp->len - 1] == '.')
! #else
! 			if (LF_ISSET(TXT_DOTTERM) && tp->len == tp->ai + 1 &&
! 			    tp->lb[tp->len - multi_back(sp, tp->lb, &tp->lb[tp->len])] == '.')
! #endif /*MULTIBYTE*/
! 			{
  notlast:			CIRCLEQ_REMOVE(tiqh, tp, q);
  				text_free(tp);
  				goto done;
***************
*** 338,344 ****
--- 349,362 ----
  	}
  	/* NOTREACHED */
  
+ #if 1
  done:	return (rval);
+ #else
+ done:
+ 	if (multi_ext2int_text(sp, tiqh, O_INPUTENCODING))
+ 		goto err;
+ 	return rval;
+ #endif /*MULTIBYTE*/
  
  err:	
  alloc_err:
Index: ex/ex_usage.c
Prereq: 	10.13 
*** nvi-1.79/ex/ex_usage.c	Wed Jun 26 23:28:29 1996
--- nvi-1.79-m17n/ex/ex_usage.c	Fri Feb 21 22:51:03 1997
***************
*** 146,152 ****
--- 146,156 ----
  {
  	GS *gp;
  	VIKEYS const *kp;
+ #ifndef MULTIBYTE
  	int key;
+ #else
+ 	CHAR_T key;
+ #endif
  
  	gp = sp->gp;
  	switch (cmdp->argc) {
Index: ex/ex_version.c
Prereq: 	10.31 
*** nvi-1.79/ex/ex_version.c	Fri Aug 23 00:57:11 1996
--- nvi-1.79-m17n/ex/ex_version.c	Tue Dec 31 00:08:51 1996
***************
*** 22,27 ****
--- 22,30 ----
  
  #include "../common/common.h"
  #include "version.h"
+ #ifdef MULTIBYTE
+ #include "mversion.h"
+ #endif
  
  /*
   * ex_version -- :version
***************
*** 35,39 ****
--- 38,45 ----
  	EXCMD *cmdp;
  {
  	msgq(sp, M_INFO, VI_VERSION);
+ #ifdef MULTIBYTE
+ 	msgq(sp, M_INFO, MULTIBYTE_VERSION);
+ #endif
  	return (0);
  }
Index: ex/ex_write.c
Prereq: 	10.30 
*** nvi-1.79/ex/ex_write.c	Sat Jul 13 09:55:27 1996
--- nvi-1.79-m17n/ex/ex_write.c	Mon Jun 16 11:18:35 1997
***************
*** 138,144 ****
--- 138,149 ----
  {
  	MARK rm;
  	int flags;
+ #ifndef MULTIBYTE
  	char *name, *p;
+ #else
+ 	char *name;
+ 	CHAR_T *p;
+ #endif
  
  	NEEDFILE(sp, cmdp);
  
***************
*** 319,325 ****
  	ccnt = 0;
  	lcnt = 0;
  	msg = "253|Writing...";
! 	if (tline != 0)
  		for (; fline <= tline; ++fline, ++lcnt) {
  			/* Caller has to provide any interrupt message. */
  			if ((lcnt + 1) % INTERRUPT_CHECK == 0) {
--- 324,338 ----
  	ccnt = 0;
  	lcnt = 0;
  	msg = "253|Writing...";
! 	if (tline != 0) {
! #ifdef MULTIBYTE
! 		void *cnvstate;
! 		CHAR_T *cnvtmp;
! 		size_t cnvtmplen;
! 
! 		GET_SPACE_RET(sp, cnvtmp, cnvtmplen, 256);
! 		cnvstate = multi_cnvstart(sp, O_STR(sp, O_FILEENCODING));
! #endif /*MULTIBYTE*/
  		for (; fline <= tline; ++fline, ++lcnt) {
  			/* Caller has to provide any interrupt message. */
  			if ((lcnt + 1) % INTERRUPT_CHECK == 0) {
***************
*** 331,345 ****
--- 344,403 ----
  					msg = NULL;
  				}
  			}
+ #ifndef MULTIBYTE
  			if (db_get(sp, fline, DBG_FATAL, &p, &len))
  				goto err;
  			if (fwrite(p, 1, len, fp) != len)
  				goto err;
  			ccnt += len;
+ #else
+ 			if (db_get(sp, fline, DBG_FATAL, &p, &len)) {
+ 				FREE_SPACE(sp, cnvtmp, cnvtmplen);
+ 				goto err;
+ 			}
+ 
+ 		    {
+ 			size_t ilen;
+ 			int mbflg;
+ 			
+ 			ilen = multi_int2extlen(sp, p, len, &mbflg, cnvstate);
+ 			if (!mbflg) {
+ 				if (fwrite(p, 1, len, fp) != len) {
+ 					FREE_SPACE(sp, cnvtmp, cnvtmplen);
+ 					multi_cnvfinish(sp, cnvstate);
+ 					goto err;
+ 				}
+ 				ccnt += len;
+ 				goto mbskip;
+ 			}
+ 			if (cnvtmplen < ilen)
+ 				ADD_SPACE_RET(sp, cnvtmp, cnvtmplen, ilen);
+ 			
+ 			/* we use memcpy() twice, it should be avoided. */
+ 			memcpy(cnvtmp, p, len);
+ 			if (multi_int2ext(sp, cnvtmp, len, ilen, cnvstate)) {
+ 				FREE_SPACE(sp, cnvtmp, cnvtmplen);
+ 				multi_cnvfinish(sp, cnvstate);
+ 				goto err;
+ 			}
+ 			if (fwrite(cnvtmp, 1, ilen, fp) != ilen) {
+ 				FREE_SPACE(sp, cnvtmp, cnvtmplen);
+ 				multi_cnvfinish(sp, cnvstate);
+ 				goto err;
+ 			}
+ 			ccnt += ilen;
+ mbskip:;
+ 		    }
+ #endif /*MULTIBYTE*/
  			if (putc('\n', fp) != '\n')
  				break;
  			++ccnt;
  		}
+ #ifdef MULTIBYTE
+ 		FREE_SPACE(sp, cnvtmp, cnvtmplen);
+ 		multi_cnvfinish(sp, cnvstate);
+ #endif
+ 	}
  
  	if (fflush(fp))
  		goto err;
***************
*** 357,362 ****
--- 415,423 ----
  
  	rval = 0;
  	if (0) {
+ #ifdef MULTIBYTE
+ alloc_err:;
+ #endif
  err:		if (!F_ISSET(sp->ep, F_MULTILOCK))
  			msgq_str(sp, M_SYSERR, name, "%s");
  		(void)fclose(fp);
Index: ex/mversion.h
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/ex/mversion.h	Tue Jun 17 23:23:42 1997
***************
*** 0 ****
--- 1,2 ----
+ #define	MULTIBYTE_VERSION \
+ 	"multilingualization patch version 06/17/97 23:30  by Jun-ichiro itojun Itoh."
Index: include/cl_extern.h
*** nvi-1.79/include/cl_extern.h	Wed Oct 23 22:53:08 1996
--- nvi-1.79-m17n/include/cl_extern.h	Wed Aug 20 14:47:18 1997
***************
*** 27,33 ****
--- 27,37 ----
  #ifndef HAVE_CURSES_TIGETSTR
  int tigetnum __P((char *));
  #endif
+ #ifndef MULTIBYTE
  int cl_addstr __P((SCR *, const char *, size_t));
+ #else
+ int cl_addstr __P((SCR *, const CHAR_T *, size_t));
+ #endif
  int cl_attr __P((SCR *, scr_attr_t, int));
  int cl_baud __P((SCR *, u_long *));
  int cl_bell __P((SCR *));
Index: include/com_extern.h
*** nvi-1.79/include/com_extern.h	Wed Oct 23 22:53:09 1996
--- nvi-1.79-m17n/include/com_extern.h	Wed Aug 20 14:47:19 1997
***************
*** 101,107 ****
--- 101,110 ----
  int v_key_init __P((SCR *));
  void v_key_ilookup __P((SCR *));
  size_t v_key_len __P((SCR *, ARG_CHAR_T));
+ size_t v_key_len1 __P((SCR *, ARG_CHAR_T));
  CHAR_T *v_key_name __P((SCR *, ARG_CHAR_T));
+ CHAR_T *v_key_name1 __P((SCR *, ARG_CHAR_T));
+ size_t v_key_blen __P((SCR *, ARG_CHAR_T));
  int v_key_val __P((SCR *, ARG_CHAR_T));
  int v_event_push __P((SCR *, EVENT *, CHAR_T *, size_t, u_int));
  int v_event_get __P((SCR *, EVENT *, int, u_int32_t));
***************
*** 140,145 ****
--- 143,259 ----
  const char *msg_cmsg __P((SCR *, cmsg_t, size_t *));
  const char *msg_cat __P((SCR *, const char *, size_t *));
  char *msg_print __P((SCR *, const char *, int *));
+ #ifdef CANNA
+ int canna_enabled __P((SCR *));
+ #endif
+ #ifdef CANNA
+ int canna_fenceactive __P((SCR *));
+ #endif
+ #ifdef CANNA
+ void canna_on __P((SCR *));
+ #endif
+ #ifdef CANNA
+ void canna_off __P((SCR *));
+ #endif
+ #ifdef CANNA
+ void canna_force_on __P((SCR *));
+ #endif
+ #ifdef CANNA
+ void canna_force_off __P((SCR *));
+ #endif
+ #ifdef CANNA
+ int canna_init __P((SCR *));
+ #endif
+ #ifdef CANNA
+ int canna_end __P((SCR *));
+ #endif
+ #ifdef CANNA
+ void canna_setserver __P((SCR *, char *));
+ #endif
+ #ifdef CANNA
+ int canna_modelinesw __P((SCR *, int));
+ #endif
+ #ifdef CANNA
+ int canna_modeline __P((SCR *));
+ #endif
+ #ifdef MULTIBYTE
+ u_int multi_chclass __P((CHAR_T *, u_int));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_byte_c __P((SCR *, ARG_CHAR_T));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_byte __P((SCR *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_fix __P((SCR *, const CHAR_T *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_back __P((SCR *, const CHAR_T *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_len_c __P((SCR *, ARG_CHAR_T));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_len __P((SCR *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ CHAR_T *multi_name __P((SCR *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ CHAR_T *multi_rawname __P((SCR *, const CHAR_T *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_isnone __P((SCR *, ARG_CHAR_T));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_iswestern __P((SCR *, ARG_CHAR_T));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_Wordbound __P((u_int, u_int, int));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_wordbound __P((u_int, u_int, int));
+ #endif
+ #ifdef MULTIBYTE
+ char *multi_predict_region __P((SCR *, MARK *, MARK *, char *, char *, int));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_ext2int_text __P((SCR *, TEXTH *, int));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_ext2int_region __P((SCR *, MARK *, MARK *, int, char *, int, int));
+ #endif
+ #ifdef MULTIBYTE
+ void *multi_cnvstart __P((SCR *, char *));
+ #endif
+ #ifdef MULTIBYTE
+ void multi_cnvfinish __P((SCR *, void *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_int2extlen __P((SCR *, CHAR_T *, size_t, int *, void *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_int2ext __P((SCR *, CHAR_T *, size_t, size_t, void *));
+ #endif
+ #ifdef MULTIBYTE
+ void multi_keyinput_stateinit __P((SCR *));
+ #endif
+ #ifdef MULTIBYTE
+ void multi_keyinput __P((SCR *, CHAR_T *, size_t *, CHAR_T *, size_t *, int *));
+ #endif
+ #ifdef MULTIBYTE
+ int multi_isencoding __P((const char *, int));
+ #endif
+ #ifdef MULTIBYTE
+ void v_fep_on __P((SCR *));
+ #endif
+ #ifdef MULTIBYTE
+ void v_fep_off __P((SCR *));
+ #endif
+ #ifdef MULTIBYTE
+ void v_fep_force_off __P((SCR *));
+ #endif
  int opts_init __P((SCR *, int *));
  int opts_set __P((SCR *, ARGS *[], char *));
  int o_set __P((SCR *, int, u_int, char *, u_long));
***************
*** 166,171 ****
--- 280,300 ----
  int f_w1200 __P((SCR *, OPTION *, char *, u_long *));
  int f_w9600 __P((SCR *, OPTION *, char *, u_long *));
  int f_window __P((SCR *, OPTION *, char *, u_long *));
+ #ifdef MULTIBYTE
+ int f_fileencoding __P((SCR *, OPTION *, char *, u_long *));
+ #endif
+ #ifdef MULTIBYTE
+ int f_displayencoding __P((SCR *, OPTION *, char *, u_long *));
+ #endif
+ #ifdef MULTIBYTE
+ int f_inputencoding __P((SCR *, OPTION *, char *, u_long *));
+ #endif
+ #ifdef CANNA
+ int f_canna __P((SCR *, OPTION *, char *, u_long *));
+ #endif
+ #ifdef CANNA
+ int f_cannaserver __P((SCR *, OPTION *, char *, u_long *));
+ #endif
  int put __P((SCR *, CB *, CHAR_T *, MARK *, MARK *, int));
  int rcv_tmp __P((SCR *, EXF *, char *));
  int rcv_init __P((SCR *));
